Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3490)
@@ -8,4 +8,5 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
    !!            3.3  !  2010-09  (D.Storkey and E.O'Dea)  bug fixes
+   !!            3.4  !  2012-09  (G. Reffray and J. Chanut) New inputs + mods
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -27,6 +28,7 @@
    USE bdy_oce         ! ocean open boundary conditions
    USE daymod          ! calendar
+   USE wrk_nemo        ! Memory allocation
    USE tideini
-   USE tide_mod
+!   USE tide_mod       ! Useless ??
    USE fldread, ONLY: fld_map
 
@@ -34,6 +36,6 @@
    PRIVATE
 
-   PUBLIC   bdytide_init  ! routine called in nemo_init
-   PUBLIC   tide_update   ! routine called in bdydyn
+   PUBLIC   bdytide_init     ! routine called in bdy_init
+   PUBLIC   bdytide_update   ! routine called in bdy_dta
 
    TYPE, PUBLIC ::   TIDES_DATA     !: Storage for external tidal harmonics data
@@ -47,5 +49,5 @@
 
    TYPE(TIDES_DATA), PUBLIC, DIMENSION(jp_bdy), TARGET :: tides  !: External tidal harmonics data
-   
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -66,22 +68,31 @@
       !!-------------------
       CHARACTER(len=80)                         ::   filtide             !: Filename root for tidal input files
-      LOGICAL                                   ::   ln_conjug = .FALSE. !: F/T : tidal data in complex/complex conjugate
+      LOGICAL                                   ::   ln_bdytide_2ddta    !: If true, read 2d harmonic data
+      LOGICAL                                   ::   ln_bdytide_conj     !: If true, assume complex conjugate tidal data
       !!
       INTEGER                                   ::   ib_bdy, itide, ib   !: dummy loop indices
+      INTEGER                                   ::   ii, ij              !: dummy loop indices
       INTEGER                                   ::   inum, igrd
-      INTEGER, DIMENSION(3)                     ::   ilen0               !: length of boundary data (from OBC arrays)
+      INTEGER, DIMENSION(3)                     ::   ilen0       !: length of boundary data (from OBC arrays)
+      INTEGER, POINTER, DIMENSION(:)            ::   nblen, nblenrim     ! short cuts
       CHARACTER(len=80)                         ::   clfile              !: full file name for tidal input file 
       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)    ::   dta_read            !: work space to read in tidal harmonics data
+      REAL(wp), POINTER, DIMENSION(:,:)         ::   ztr, zti            !:  "     "    "   "   "   "        "      " 
       !!
       TYPE(TIDES_DATA),  POINTER                ::   td                  !: local short cut   
       !!
-      NAMELIST/nambdy_tide/filtide, ln_conjug
+      NAMELIST/nambdy_tide/filtide, ln_bdytide_2ddta, ln_bdytide_conj
       !!----------------------------------------------------------------------
 
       IF( nn_timing == 1 ) CALL timing_start('bdytide_init')
 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'bdytide_init : initialization of tidal harmonic forcing at open boundaries'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~'
+      IF (nb_bdy>0) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'bdytide_init : initialization of tidal harmonic forcing at open boundaries'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+
+      ln_bdytide_2ddta = .FALSE.
+      ln_bdytide_conj  = .FALSE.
 
       REWIND(numnam)
@@ -90,4 +101,6 @@
 
             td => tides(ib_bdy)
+            nblen => idx_bdy(ib_bdy)%nblen
+            nblenrim => idx_bdy(ib_bdy)%nblenrim
 
             ! Namelist nambdy_tide : tidal harmonic forcing at open boundaries
@@ -97,65 +110,145 @@
             READ  ( numnam, nambdy_tide )
             !                                               ! Parameter control and print
+            IF(lwp) WRITE(numout,*) '  '
             IF(lwp) WRITE(numout,*) '          Namelist nambdy_tide : tidal harmonic forcing at open boundaries'
-            IF(lwp) WRITE(numout,*) '             tidal components specified ', nb_harmo
-            IF(lwp) WRITE(numout,*) '                ', Wave(ntide(1:nb_harmo))%cname_tide
-            IF(lwp) WRITE(numout,*) '             associated phase speeds (deg/hr) : '
-            IF(lwp) WRITE(numout,*) '                ', omega_tide(1:nb_harmo)
+            IF(lwp) WRITE(numout,*) '             read tidal data in 2d files: ', ln_bdytide_2ddta
+            IF(lwp) WRITE(numout,*) '             assume complex conjugate   : ', ln_bdytide_conj
+            IF(lwp) WRITE(numout,*) '             Number of tidal components to read: ', nb_harmo
+            IF(lwp) THEN 
+                    WRITE(numout,*) '             Tidal cpt name    -     Phase speed (deg/hr)'            
+               DO itide = 1, nb_harmo
+                  WRITE(numout,*)  '             ', Wave(ntide(itide))%cname_tide, omega_tide(itide)   
+               END DO
+            ENDIF 
+            IF(lwp) WRITE(numout,*) ' '
 
             ! Allocate space for tidal harmonics data - get size from OBC data arrays
             ! -----------------------------------------------------------------------
 
-            ilen0(1) = SIZE( dta_bdy(ib_bdy)%ssh ) 
+            ! JC: If FRS scheme is used, we assume that tidal is needed over the whole
+            ! relaxation area      
+            IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
+               ilen0(:)=nblen(:)
+            ELSE
+               ilen0(:)=nblenrim(:)
+            ENDIF
+
             ALLOCATE( td%ssh0( ilen0(1), nb_harmo, 2 ) )
             ALLOCATE( td%ssh ( ilen0(1), nb_harmo, 2 ) )
 
-            ilen0(2) = SIZE( dta_bdy(ib_bdy)%u2d ) 
             ALLOCATE( td%u0( ilen0(2), nb_harmo, 2 ) )
             ALLOCATE( td%u ( ilen0(2), nb_harmo, 2 ) )
 
-            ilen0(3) = SIZE( dta_bdy(ib_bdy)%v2d ) 
             ALLOCATE( td%v0( ilen0(3), nb_harmo, 2 ) )
             ALLOCATE( td%v ( ilen0(3), nb_harmo, 2 ) )
 
-            ALLOCATE( dta_read( MAXVAL(ilen0), 1, 1 ) )
-
-            ! Open files and read in tidal forcing data
-            ! -----------------------------------------
-
-            DO itide = 1, nb_harmo
-               !                                                              ! SSH fields
-               clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_T.nc'
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'z1' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
-               td%ssh0(:,itide,1) = dta_read(1:ilen0(1),1,1)
-               CALL fld_map( inum, 'z2' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
-               td%ssh0(:,itide,2) = dta_read(1:ilen0(1),1,1)
+            td%ssh0(:,:,:) = 0.e0
+            td%ssh(:,:,:) = 0.e0
+            td%u0(:,:,:) = 0.e0
+            td%u(:,:,:) = 0.e0
+            td%v0(:,:,:) = 0.e0
+            td%v(:,:,:) = 0.e0
+
+            IF (ln_bdytide_2ddta) THEN
+               ! It is assumed that each data file contains all complex harmonic amplitudes
+               ! given on the data domain (ie global, jpidta x jpjdta)
+               !
+               CALL wrk_alloc( jpi, jpj, zti, ztr )
+               !
+               ! SSH fields
+               clfile = TRIM(filtide)//'_grid_T.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 1                       ! Everything is at T-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_z1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_z2', zti(:,:) ) 
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%ssh0(ib,itide,1) = ztr(ii,ij)
+                     td%ssh0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO 
                CALL iom_close( inum )
-               !                                                              ! U fields
-               clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_U.nc'
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'u1' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
-               td%u0(:,itide,1) = dta_read(1:ilen0(2),1,1)
-               CALL fld_map( inum, 'u2' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
-               td%u0(:,itide,2) = dta_read(1:ilen0(2),1,1)
+               !
+               ! U fields
+               clfile = TRIM(filtide)//'_grid_U.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 2                       ! Everything is at U-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_u1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_u2', zti(:,:) )
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%u0(ib,itide,1) = ztr(ii,ij)
+                     td%u0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO
                CALL iom_close( inum )
-               !                                                              ! V fields
-               clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_V.nc'
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'v1' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
-               td%v0(:,itide,1) = dta_read(1:ilen0(3),1,1)
-               CALL fld_map( inum, 'v2' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
-               td%v0(:,itide,2) = dta_read(1:ilen0(3),1,1)
+               !
+               ! V fields
+               clfile = TRIM(filtide)//'_grid_V.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 3                       ! Everything is at V-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_v1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_v2', zti(:,:) )
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%v0(ib,itide,1) = ztr(ii,ij)
+                     td%v0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO  
                CALL iom_close( inum )
-               IF ( ln_conjug ) THEN
-                  IF(lwp) WRITE(numout,*) '       The tidal input data are written in complex conjugate'
-                  td%ssh0(:,itide,2) = - td%ssh0(:,itide,2)
-                  td%u0  (:,itide,2) = - td%u0  (:,itide,2)
-                  td%v0  (:,itide,2) = - td%v0  (:,itide,2)
-               ENDIF
-               !
-            END DO ! end loop on tidal components
+               !
+               CALL wrk_dealloc( jpi, jpj, ztr, zti ) 
+               !
+            ELSE            
+               !
+               ! Read tidal data only on bdy segments
+               ! 
+               ALLOCATE( dta_read( MAXVAL(ilen0(1:3)), 1, 1 ) )
+
+               ! Open files and read in tidal forcing data
+               ! -----------------------------------------
+
+               DO itide = 1, nb_harmo
+                  !                                                              ! SSH fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_T.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'z1' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
+                  td%ssh0(:,itide,1) = dta_read(1:ilen0(1),1,1)
+                  CALL fld_map( inum, 'z2' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
+                  td%ssh0(:,itide,2) = dta_read(1:ilen0(1),1,1)
+                  CALL iom_close( inum )
+                  !                                                              ! U fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_U.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'u1' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
+                  td%u0(:,itide,1) = dta_read(1:ilen0(2),1,1)
+                  CALL fld_map( inum, 'u2' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
+                  td%u0(:,itide,2) = dta_read(1:ilen0(2),1,1)
+                  CALL iom_close( inum )
+                  !                                                              ! V fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_V.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'v1' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
+                  td%v0(:,itide,1) = dta_read(1:ilen0(3),1,1)
+                  CALL fld_map( inum, 'v2' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
+                  td%v0(:,itide,2) = dta_read(1:ilen0(3),1,1)
+                  CALL iom_close( inum )
+                  !
+               END DO ! end loop on tidal components
+               !
+               DEALLOCATE( dta_read )
+            ENDIF ! ln_bdytide_2ddta=.true.
             !
-            DEALLOCATE( dta_read )
+            IF ( ln_bdytide_conj ) THEN ! assume complex conjugate in data files
+               td%ssh0(:,:,2) = - td%ssh0(:,:,2)
+               td%u0  (:,:,2) = - td%u0  (:,:,2)
+               td%v0  (:,:,2) = - td%v0  (:,:,2)
+            ENDIF
             !
          ENDIF ! nn_dyn2d_dta(ib_bdy) .ge. 2
@@ -167,7 +260,7 @@
    END SUBROUTINE bdytide_init
 
-   SUBROUTINE tide_update ( kt, idx, dta, td, jit, time_offset )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE tide_update  ***
+   SUBROUTINE bdytide_update ( kt, idx, dta, td, jit, time_offset )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdytide_update  ***
       !!                
       !! ** Purpose : - Add tidal forcing to ssh, u2d and v2d OBC data arrays. 
@@ -186,11 +279,16 @@
                                                         ! etc.
       !!
+      INTEGER, DIMENSION(3)            ::   ilen0       !: length of boundary data (from OBC arrays)
       INTEGER                          :: itide, igrd, ib   ! dummy loop indices
       INTEGER                          :: time_add          ! time offset in units of timesteps
-      REAL(wp)                         :: z_arg, z_sarg, zflag      
+      REAL(wp)                         :: z_arg, z_sarg, zflag, zramp      
       REAL(wp), DIMENSION(jpmax_harmo) :: z_sist, z_cost
       !!----------------------------------------------------------------------
 
-      IF( nn_timing == 1 ) CALL timing_start('tide_update')
+      IF( nn_timing == 1 ) CALL timing_start('bdytide_update')
+
+      ilen0(1) =  SIZE(td%ssh(:,1,1))
+      ilen0(2) =  SIZE(td%u(:,1,1))
+      ilen0(3) =  SIZE(td%v(:,1,1))
 
       zflag=1
@@ -205,6 +303,6 @@
         IF(lwp) THEN
            WRITE(numout,*)
-           WRITE(numout,*) 'bdy_tide : (re)Initialization of the tidal bdy forcing at kt=',kt
-           WRITE(numout,*) '~~~~~~~ '
+           WRITE(numout,*) 'bdytide_update : (re)Initialization of the tidal bdy forcing at kt=',kt
+           WRITE(numout,*) '~~~~~~~~~~~~~~ '
         ENDIF
         !
@@ -225,4 +323,8 @@
       ENDIF
 
+      ! Linear ramp on tidal component at open boundaries 
+      zramp = 1.
+      IF (ln_tide_ramp) zramp = MIN(MAX( (z_arg + (kt_tide-nit000)*rdt)/(rdttideramp*rday),0.),1.)
+
       DO itide = 1, nb_harmo
          z_sarg = z_arg * omega_tide(itide)
@@ -233,20 +335,20 @@
       DO itide = 1, nb_harmo
          igrd=1                              ! SSH on tracer grid
-         DO ib = 1, idx%nblenrim(igrd)
-            dta%ssh(ib) = dta%ssh(ib) + td%ssh(ib,itide,1)*z_cost(itide) + td%ssh(ib,itide,2)*z_sist(itide)
+         DO ib = 1, ilen0(igrd)
+            dta%ssh(ib) = dta%ssh(ib) + zramp*(td%ssh(ib,itide,1)*z_cost(itide) + td%ssh(ib,itide,2)*z_sist(itide))
          END DO
          igrd=2                              ! U grid
-         DO ib=1, idx%nblenrim(igrd)
-            dta%u2d(ib) = dta%u2d(ib) + td%u  (ib,itide,1)*z_cost(itide) + td%u  (ib,itide,2)*z_sist(itide)
+         DO ib = 1, ilen0(igrd)
+            dta%u2d(ib) = dta%u2d(ib) + zramp*(td%u  (ib,itide,1)*z_cost(itide) + td%u  (ib,itide,2)*z_sist(itide))
          END DO
          igrd=3                              ! V grid
-         DO ib=1, idx%nblenrim(igrd)
-            dta%v2d(ib) = dta%v2d(ib) + td%v  (ib,itide,1)*z_cost(itide) + td%v  (ib,itide,2)*z_sist(itide)
+         DO ib = 1, ilen0(igrd) 
+            dta%v2d(ib) = dta%v2d(ib) + zramp*(td%v  (ib,itide,1)*z_cost(itide) + td%v  (ib,itide,2)*z_sist(itide))
          END DO
       END DO
       !
-      IF( nn_timing == 1 ) CALL timing_stop('tide_update')
+      IF( nn_timing == 1 ) CALL timing_stop('bdytide_update')
       !
-   END SUBROUTINE tide_update
+   END SUBROUTINE bdytide_update
 
    SUBROUTINE tide_init_elevation( idx, td )
@@ -257,21 +359,25 @@
       TYPE(TIDES_DATA),INTENT( inout )   ::   td      ! tidal harmonics data
       !! * Local declarations
+      INTEGER, DIMENSION(1)            ::   ilen0       !: length of boundary data (from OBC arrays)
       REAL(wp),ALLOCATABLE, DIMENSION(:) ::   mod_tide, phi_tide
       INTEGER                            ::   itide, igrd, ib      ! dummy loop indices
 
-      igrd=1                                 ! SSH on tracer grid.
-
-      ALLOCATE(mod_tide(idx%nblenrim(igrd)),phi_tide(idx%nblenrim(igrd)))
+      igrd=1   
+                              ! SSH on tracer grid.
+   
+      ilen0(1) =  SIZE(td%ssh0(:,1,1))
+
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
 
       DO itide = 1, nb_harmo
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             mod_tide(ib)=SQRT(td%ssh0(ib,itide,1)**2.+td%ssh0(ib,itide,2)**2.)
             phi_tide(ib)=ATAN2(-td%ssh0(ib,itide,2),td%ssh0(ib,itide,1))
          END DO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1 , ilen0(igrd)
             mod_tide(ib)=mod_tide(ib)*ftide(itide)
             phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
          ENDDO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1 , ilen0(igrd)
             td%ssh(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
             td%ssh(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
@@ -290,21 +396,25 @@
       TYPE(TIDES_DATA),INTENT( inout )      ::   td      ! tidal harmonics data
       !! * Local declarations
+      INTEGER, DIMENSION(3)            ::   ilen0       !: length of boundary data (from OBC arrays)
       REAL(wp),ALLOCATABLE, DIMENSION(:) ::   mod_tide, phi_tide
       INTEGER                            ::   itide, igrd, ib      ! dummy loop indices
 
+      ilen0(2) =  SIZE(td%u0(:,1,1))
+      ilen0(3) =  SIZE(td%v0(:,1,1))
+
       igrd=2                                 ! U grid.
 
-      ALLOCATE(mod_tide(idx%nblenrim(igrd)),phi_tide(idx%nblenrim(igrd)))
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
 
       DO itide = 1, nb_harmo
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             mod_tide(ib)=SQRT(td%u0(ib,itide,1)**2.+td%u0(ib,itide,2)**2.)
             phi_tide(ib)=ATAN2(-td%u0(ib,itide,2),td%u0(ib,itide,1))
          END DO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             mod_tide(ib)=mod_tide(ib)*ftide(itide)
             phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
          ENDDO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             td%u(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
             td%u(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
@@ -314,18 +424,18 @@
       DEALLOCATE(mod_tide,phi_tide)
 
-      igrd=3                                 ! U grid.
-
-      ALLOCATE(mod_tide(idx%nblenrim(igrd)),phi_tide(idx%nblenrim(igrd)))
+      igrd=3                                 ! V grid.
+
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
 
       DO itide = 1, nb_harmo
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             mod_tide(ib)=SQRT(td%v0(ib,itide,1)**2.+td%v0(ib,itide,2)**2.)
             phi_tide(ib)=ATAN2(-td%v0(ib,itide,2),td%v0(ib,itide,1))
          END DO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             mod_tide(ib)=mod_tide(ib)*ftide(itide)
             phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
          ENDDO
-         DO ib = 1, idx%nblenrim(igrd)
+         DO ib = 1, ilen0(igrd)
             td%v(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
             td%v(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
@@ -341,11 +451,10 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE bdytide_init                ! Empty routine
+   SUBROUTINE bdytide_init             ! Empty routine
+      WRITE(*,*) 'bdytide_init: You should not have seen this print! error?'
    END SUBROUTINE bdytide_init
-   SUBROUTINE tide_data                ! Empty routine
-   END SUBROUTINE tide_data
-   SUBROUTINE tide_update( kt, jit )   ! Empty routine
-      WRITE(*,*) 'tide_update: You should not have seen this print! error?', kt, jit
-   END SUBROUTINE tide_update
+   SUBROUTINE bdytide_update( kt, jit )   ! Empty routine
+      WRITE(*,*) 'bdytide_update: You should not have seen this print! error?', kt, jit
+   END SUBROUTINE bdytide_update
 #endif
 
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3490)
@@ -22,5 +22,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
-   USE phycst
+
 
    IMPLICIT NONE
@@ -28,5 +28,5 @@
 
    PUBLIC bdy_tra      ! routine called in tranxt.F90 
-   PUBLIC bdy_tra_dmp  ! routine called in tranxt.F90 
+   PUBLIC bdy_tra_dmp  ! routine called in step.F90 
 
    !!----------------------------------------------------------------------
@@ -65,4 +65,8 @@
          END SELECT
       ENDDO
+      !
+      ! Boundary points should be updated
+      IF (nb_bdy>0) CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )
+      IF (nb_bdy>0) CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
 
    END SUBROUTINE bdy_tra
@@ -98,6 +102,4 @@
       END DO 
       !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
-      !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
       !
@@ -133,6 +135,4 @@
          END DO
       END DO
-      !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
       !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
@@ -190,6 +190,4 @@
       END DO
       !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
-      !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
       !
@@ -229,6 +227,4 @@
          END DO
       END DO
-      !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
       !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
@@ -262,14 +258,14 @@
                ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-               zwgt = idx_bdy(ib_bdy)%nbw(ib,igrd) / ( rn_time_dmp(ib_bdy) * rday )
+               zwgt = idx_bdy(ib_bdy)%nbd(ib,igrd)
                DO ik = 1, jpkm1
-                  tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) + zwgt * ( dta_bdy(ib_bdy)%tem(ib,ik) - tsb(ii,ij,ik,jp_tem) ) ) * tmask(ii,ij,ik)
-                  tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) + zwgt * ( dta_bdy(ib_bdy)%sal(ib,ik) - tsb(ii,ij,ik,jp_sal) ) ) * tmask(ii,ij,ik)
+                  zta = zwgt * ( dta_bdy(ib_bdy)%tem(ib,ik) - tsb(ii,ij,ik,jp_tem) ) * tmask(ii,ij,ik)
+                  zsa = zwgt * ( dta_bdy(ib_bdy)%sal(ib,ik) - tsb(ii,ij,ik,jp_sal) ) * tmask(ii,ij,ik)
+                  tsa(ii,ij,ik,jp_tem) = tsa(ii,ij,ik,jp_tem) + zta
+                  tsa(ii,ij,ik,jp_sal) = tsa(ii,ij,ik,jp_sal) + zsa
                END DO
             END DO
          ENDIF
       ENDDO
-      !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )  ;  CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
       !
       IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_dmp')
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/tideini.F90	(revision 3490)
@@ -26,5 +26,6 @@
        ftide
 
-  LOGICAL, PUBLIC :: ln_tide_pot = .false.
+  LOGICAL, PUBLIC :: ln_tide_pot = .false., ln_tide_ramp = .false.
+  REAL(wp), PUBLIC :: rdttideramp 
   INTEGER, PUBLIC :: nb_harmo
   INTEGER, PUBLIC, ALLOCATABLE, DIMENSION(:) :: ntide
@@ -46,5 +47,5 @@
     CHARACTER(LEN=4), DIMENSION(jpmax_harmo) :: clname
     !
-    NAMELIST/nam_tide/ln_tide_pot,clname
+    NAMELIST/nam_tide/ln_tide_pot, ln_tide_ramp, rdttideramp, clname
     !!----------------------------------------------------------------------
 
@@ -54,5 +55,5 @@
           WRITE(numout,*)
           WRITE(numout,*) 'tide_init : Initialization of the tidal components'
-          WRITE(numout,*) '~~~~~~~ '
+          WRITE(numout,*) '~~~~~~~~~ '
        ENDIF
        !
@@ -77,4 +78,10 @@
           WRITE(numout,*) '        Namelist nam_tide'
           WRITE(numout,*) '        nb_harmo    = ', nb_harmo
+          WRITE(numout,*) '        ln_tide_ramp = ', ln_tide_ramp 
+          WRITE(numout,*) '        rdttideramp = ', rdttideramp
+          IF (ln_tide_ramp.AND.((nitend-nit000+1)*rdt/rday < rdttideramp)) &
+          & CALL ctl_stop('rdttideramp must be lower than run duration')
+          IF (ln_tide_ramp.AND.(rdttideramp<0.)) &
+          & CALL ctl_stop('rdttideramp must be positive')
           CALL flush(numout)
        ENDIF
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/SBC/updtide.F90	(revision 3490)
@@ -13,4 +13,5 @@
   USE sbctide
   USE dynspg_oce
+  USE tideini, ONLY: ln_tide_ramp, rdttideramp
 
   IMPLICIT NONE
@@ -33,15 +34,21 @@
     INTEGER, INTENT( in ) ::   kt,kit      ! ocean time-step index
     INTEGER  :: ji,jj,jk
+    REAL (wp) :: zramp
     REAL (wp), DIMENSION(nb_harmo) :: zwt 
-    !...............................................................................
-    ! Potentiel astronomique
     !...............................................................................
 
     pot_astro(:,:)=0.e0
+    zramp = 1.e0
 
     IF (lk_dynspg_ts) THEN
        zwt(:) = omega_tide(:)* ((kt-kt_tide)*rdt + kit*(rdt/REAL(nn_baro,wp)))
+       IF (ln_tide_ramp) THEN
+          zramp = MIN(MAX( ((kt-nit000)*rdt + kit*(rdt/REAL(nn_baro,wp)))/(rdttideramp*rday),0.),1.)
+       ENDIF
     ELSE
        zwt(:) = omega_tide(:)*(kt-kt_tide)*rdt
+       IF (ln_tide_ramp) THEN
+          zramp = MIN(MAX( ((kt-nit000)*rdt)/(rdttideramp*rday),0.),1.) 
+       ENDIF  
     ENDIF
 
@@ -49,5 +56,5 @@
        do ji=1,jpi
           do jj=1,jpj
-             pot_astro(ji,jj)=pot_astro(ji,jj) + (amp_pot(ji,jj,jk)*COS(zwt(jk)+phi_pot(ji,jj,jk)))      
+             pot_astro(ji,jj)=pot_astro(ji,jj) + zramp*(amp_pot(ji,jj,jk)*COS(zwt(jk)+phi_pot(ji,jj,jk)))      
           enddo
        enddo
Index: branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3489)
+++ branches/2012/dev_r3327_MERCATOR1_BDY/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 3490)
@@ -76,4 +76,6 @@
    USE mod_ioclient
 #endif
+   USE sbctide, ONLY: lk_tide
+
 
    IMPLICIT NONE
@@ -318,5 +320,5 @@
                             CALL  istate_init   ! ocean initial state (Dynamics and tracers)
 
-                            CALL tide_init( nit000 )    ! Initialisation of the tidal harmonics
+      IF( lk_tide       )   CALL tide_init( nit000 )    ! Initialisation of the tidal harmonics
 
       IF( lk_bdy        )   CALL     bdy_init       ! Open boundaries initialisation
